#!/usr/bin/python 
# test with loads of equal temperaments
# but fewer linear temperaments

import sys, math
import temper, temper_wrap

def write_lts(consonances, etCutoff=0.5,
        nETs=1001, highestComplexity=4, worstError=0.01):
    ets = temper_wrap.get_limited_ets(
            consonances, consonances.primes, nETs, etCutoff)
    ets.reverse()
    for et in ets[:10]:
        print et.mapping[0],
    print '...',
    for et in ets[-10:]:
        print et.mapping[0],
    print

    for lt in temper_wrap.get_linear_mappings(
            ets,
            map(temper.reduceWithinTritone, consonances),
            consonances.primes,
            len(consonances)*highestComplexity,
            worstError,
            0,19):
        print lt.invariant(),
    print "\n"

oddLimits = [(limit, temper.OddLimit(limit))
    for limit in 5, 7, 9, 11, 13, 15, 17, 19, 21]

if __name__=='__main__':
    print "RMS Optima\n"
    for num, limit in oddLimits:
        print "%2i-limit"%num
        write_lts(limit)

    print "Inconsistent ETs\n"
    for num, limit in oddLimits:
        print "%2i-limit"%num
        write_lts(limit, etCutoff=0.8)

    print "Microtemperaments\n"
    for num, limit in oddLimits:
        print "%2i-limit"%num
        write_lts(limit, etCutoff=0.7, highestComplexity=6, worstError=2/12e2)

