#!/usr/bin/python 
# test with loads of equal temperaments

import linear
from math import sqrt

primeNumbers = (2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31)

def write_lts(primes, etCutoff=0.2,
        nETs=1001, highestComplexity=4, worstError=0.002, output=1):
    highestComplexity *= len(primes)**2 * 0.125/primes[0]
    etCutoff /= sqrt(len(primes))

    ets = linear.getEqualTemperaments(primes, nETs=nETs,
            cutoff=etCutoff)
    for et in ets[:10]:
        if output==1: print et[0],
    if output==1: print '...',
    for et in ets[-10:]:
        if output==1: print et[0],
    if output==1: print

    for lt in linear.getLinearTemperaments(
            ets,
            primes,
            highestComplexity,
            worstError,
            ):
        if output==1: print lt.invariant(),
    if output==1: print "\n"

limits = range(2, 11)

def test(output=0, nETs=1001):
    if output==1: print "RMS Optima\n"
    for limit in limits:
        if output==1: print "%2i-limit"%primeNumbers[limit]
        write_lts(linear.primes[:limit+1], output=output, nETs=nETs)

    if output==1: print "Inconsistent ETs\n"
    for limit in limits:
        if output==1: print "%2i-limit"%primeNumbers[limit]
        write_lts(linear.primes[:limit+1], etCutoff=0.3, output=output, nETs=nETs)

    if output==1: print "Microtemperaments\n"
    for limit in limits:
        if output==1: print "%2i-limit"%primeNumbers[limit]
        write_lts(linear.primes[:limit+1], highestComplexity=7, worstError=5e-4, output=output, nETs=nETs)

if __name__=='__main__':
    import sys
    if len(sys.argv)>1 and sys.argv[1].startswith('pro'):
        import profile, pstats
        profile.run('test()', 'linear.prof')
        pstats.Stats('linear.prof').strip_dirs().sort_stats('cumulative').print_stats(20)
    elif len(sys.argv)>1:
        test(output=1, nETs=int(sys.argv[1]))
    else:
        test(output=1)
