#!/usr/bin/python 
# test with loads of equal temperaments
# not as many as with C, but still quite a lot

import regular_minimal as regular

def write_lts(primes, etCutoff=0.2,
        nETs=300, highestComplexity=4, worstError=0.002):
    highestComplexity *= len(primes)**2 * 0.3
    etCutoff /= regular.sqrt(len(primes))

    ets = regular.getEqualTemperaments(primes, nETs=nETs,
            cutoff=etCutoff)
    for et in ets[:10]:
        print et[0],
    print '...',
    for et in ets[-10:]:
        print et[0],
    print

    for lt in regular.getLinearTemperaments(
            ets,
            primes,
            highestComplexity,
            worstError,
            ):
        print lt.invariant(),
    print "\n"

limits = range(2, 11)

def test():
    print "RMS Optima\n"
    for limit in limits:
        print "%2i-limit"%regular.primeNumbers[limit]
        write_lts(regular.primes[:limit+1])

    print "Inconsistent ETs\n"
    for limit in limits:
        print "%2i-limit"%regular.primeNumbers[limit]
        write_lts(regular.primes[:limit+1], etCutoff=0.3)

    print "Microtemperaments\n"
    for limit in limits:
        print "%2i-limit"%regular.primeNumbers[limit]
        write_lts(regular.primes[:limit+1], highestComplexity=7, worstError=5e-4)

if __name__=='__main__':
    test()
