"""Test some rank 3 searches!"""
import regular_wedgie

def test(output=0, micro=0, highLimits=0, nano=0):
    nETs=20
    if micro or nano:
        limits = range(4,8)
    elif highLimits:
        limits = range(5, 11)
    else:
        limits = range(3, 8)

    if output:
        if micro:
            print "Rank 3 microtemperaments"
        elif nano:
            print "Rank 3 nanotemperaments"
        else:
            print "Rank 3 temperaments"
        print
    for limit in limits:
        if output:
            print
            print "*************************************************"
            print "*"
            print "*  %2i-limit" % regular_wedgie.primeNumbers[limit]
            print "*"
            print "*************************************************"
        primes = regular_wedgie.primes[:limit+1]
        complexity = 0.1 * len(primes)**2
        etCutoff = 0.17/regular_wedgie.sqrt(len(primes))
        if micro:
            nETs=30
            error = 0.0003
            complexity *= 2
            etCutoff *= 0.94
        elif nano:
            # tweaked to give Gene's strict planar examples in the 11-limit
            nETs=30
            error = 3e-5 * regular_wedgie.sqrt(len(primes))
            complexity = 0.03 * len(primes)**3
            etCutoff = 0.017*regular_wedgie.sqrt(len(primes))
        else:
            error = 0.001
        if highLimits:
            complexity *= 2

        ets = regular_wedgie.getEqualTemperaments(primes, nETs, cutoff=etCutoff)
        if output:
            print ' '.join([str(et[0]) for et in ets])

        for lt in regular_wedgie.getRegularTemperaments(
                ets, primes, complexity, error,
                rank=3, nResults=10):
            if output:
                print
                print lt

if __name__=='__main__':
    import sys
    if len(sys.argv)>1 and sys.argv[1].startswith('pro'):
        import profile, pstats
        profile.run('test()', 'planar.prof')
        pstats.Stats('planar.prof').strip_dirs().sort_stats('cumulative').print_stats(20)
    elif len(sys.argv)>1 and sys.argv[1].startswith('mic'):
        test(output=1, micro=1)
    elif len(sys.argv)>1 and sys.argv[1].startswith('nano'):
        test(output=1, nano=1)
    elif len(sys.argv)>1 and sys.argv[1].startswith('hi'):
        test(output=1, highLimits=1)
    else:
        test(output=1)
