from math import log,sqrt
pNums = 2,3,5,7,11,13,17,19,23,29,31
primes = [log(f)/log(2) for f in pNums]

def getETs(p,nETs,cutoff):
    def moreMaps(map,lim,tot,tot2):
        i,n,res = len(map),map[0]/p[0],[]
        w = map[-1]/p[i-1]/n
        tot += w
        tot2 += w*w
        if tot2 - tot**2/i > lim: return []
        if i==len(p): return [map]
        for inc in 0,1,-1:
            g = int(p[i]*n+.5)
            while 1:
                g += inc
                more = moreMaps(map+[g],lim,tot,tot2)
                res += more
                if not (more and inc): break
        return res
    res, n = [], 1
    while len(res)<nETs:
        res += moreMaps([n],(cutoff/n)**2*len(p),0,0)
        n += 1
    return res[:nETs]

def getLTs(ets,p,kmax,emax):
    lts = Cache()
    for i in range(len(ets)):
        for inv,k,b in [LT(ets[i],et2,p) for et2 in ets[i+1:]]:
            if k and k<kmax and b/k<emax: lts.add(inv,b)
    return lts.dump()[:100]

def LT(m1,m2,P):
    inv = [m1[0]*N-M*m2[0] for M,N in zip(m1,m2)[1:]]
    inv = tuple([(m,-m)[(filter(None,inv)+P)[0]<0] for m in inv])
    e1,e2 = [[x/M[0]*P[0]-1 for x in [m/p for m,p in zip(M,P)]] for M in m1,m2]
    v1,v2,cv = cov(e1,e1),cov(e2,e2),cov(e1,e2)
    return [inv] + [m1[0]*m2[0]/P[0]**2*sqrt(x)
        for x in v1+v2-2*cv,max((v1*v2-cv**2),0)]

class Cache:
    def __init__(self): self.data = {}
    def add(self,inv,bad):
        self.data[inv] = min((bad,inv),self.data.get(inv,(bad,inv)))
    def dump(self):
        dec = self.data.values()
        dec.sort()
        return zip(*dec)[1]

def cov(x,y):
    return (sum([a*b for a,b in zip(x,y)]) - sum(x)*sum(y)/len(x))/len(x)

def show(p,cut=.17,nETs=20,comp=2,err=2):
    ets = getETs(p,nETs,cut/sqrt(len(p)))
    print ' '.join([str(et[0]) for et in ets])
    for lt in getLTs(ets,p,comp*len(p)**2/p[0]/8,err/1e3): print lt,
    print ""

for kw in {},{"cut":.22,"err":5},{"nETs":30,"comp":5,"err":0.5}:
    for dim in range(2,11):
        print pNums[dim]
        show(primes[:dim+1],**kw)
tub = [log(s*(s*s-1)/sqrt((s*s+1)*7.2))/log(2) for s in range(3,9)]
for bas in [1.0]+tub,tub:
    for dim in range(2,len(bas)): show(bas[:dim+1])
