"""Test with TOP optimization"""
import regular

def test():
    limits = range(2, 8)
    print "RMS Optima\n"
    for limit in limits:
        print "%2i-limit" % regular.primeNumbers[limit]
        regular.write_lts(regular.primes[:limit+1],
                useRMS=0, error=regular.topError)

    print "Less good ETs\n"
    for limit in limits:
        print "%2i-limit" % regular.primeNumbers[limit]
        regular.write_lts(
                regular.primes[:limit+1], etCutoff=0.22, worstError=0.005,
                useRMS=0, error=regular.topError)

    print "Microtemperaments\n"
    for limit in limits:
        print "%2i-limit" % regular.primeNumbers[limit]
        regular.write_lts(
            regular.primes[:limit+1], nETs=30,
            highestComplexity=5, worstError=5e-4,
            useRMS=0, error=regular.topError)

    for f in regular.tubulongFrequencies:
      print "%.5f"%f,
    print ''

    print "Octave-Equivalent Tubulongs\n"
    for limit in range(2, len(regular.tubulongPrimes)+1):
        regular.write_lts(
                ([1.0]+regular.tubulongPrimes)[:limit+1],  worstError = 0.002)

    print "Straight Tubulongs\n"
    for limit in range(2, len(regular.tubulongPrimes)):
        regular.write_lts(regular.tubulongPrimes[:limit+1], worstError = 0.002)

if __name__=='__main__':
    test()
