import temper

testVectors = [
    [(-1, 2), (4, -1)],
    [(0, -3), (8, 1)],
    [(-1, 2), (8, 1)],
    [(-1, 2), (-4, -2)],
    [(-1, 2), (-2, -1)],
    [(0, -3), (-4, -2)],
    [(3, 1), (7, 6)],
    [(3, 1), (2, -3)],
    [(0, -3, 0), (-4, -2, 0), (-2,0,-1)],
    [(0, -3, 0), (0, 2, -2), (-2, 0, -1)],
    [(-1, 2, 0, 0), (-1, 1, 1, 1), (5, 0, 0, -2), (2, 2, -1, 0)],
    [(-1, 0, 2, 0), (-1, 1, 1, 1), (5, 0, 0, -2), (2, 2, -1, 0)],
    [(2, -1, -1, 0), (-1, 1, 1, 1), (5, 0, 0, -2), (2, 2, -1, 0)],
    [(4, -1, 0, 0), (-1, 1, 1, 1), (5, 0, 0, -2), (2, 2, -1, 0)],
    [(8, 1, 0, 0), (-1, 1, 1, 1), (5, 0, 0, -2), (2, 2, -1, 0)],
    [(-2, 2, 0, -1), (-1, 1, 1, 1), (5, 0, 0, -2), (2, 2, -1, 0)],

    [(2, 2, -1, 0, 0),
     (-29, 0, 0, 0, 0),
     (0, -29, 29, 0, 0),
     (0, 29, 0, -29, 0),
     (0, 0, 0, 29, -29)],


    [(2, 2, -1, 0, 0),
     (2, -1, 2, -1, 0),
     (0, -3, 1, 1, 1),
     (-3, 1, -1, -1, 1),
     (-3, 0, 0, 1, -1)],


    [(0, -3), (4, -1)],

    [(-3, 2, -1,  2,  0),
     ( 5, 0,  0, -2,  0),
     (-3, 0,  0,  1, -1),
     (-3,-2,  0,  0,  2),
     (-1,-2,  4,  0,  0),
     ],

    [(-3,  2, -1,  2,  0),
     ( 5,  0,  0, -2,  0),
     (-1,  0,  0,  0, -1),
     (-4,  2,  0,  0,  0),
     ( 2,  1,  2,  0, -1)],

    [(-3,  2, -1,  2,  0),
     ( 5,  0,  0, -2,  0),
     (-3,  0,  0,  1, -1),
     ( 1, -1,  2, -1,  1),
     ( 1,  0,  2,  0, -1),
    ],

]


if __name__=='__main__':
  for unisonVectors in testVectors:
    print "\n\nUnison vectors"
    vectors = []
    for vector in unisonVectors:
      vectors.append(temper.reduceWithinTritone(vector)) 
    print vectors
    try:
      scale = temper.temperOut(vectors[1:], vectors[0])
      print scale
      firstMapping = scale.invariant()
      # see if you can make do without the chromatic unison vector
      nPrimes = len(vectors[0])
      for chromaticPrime in range(1,nPrimes):
        chroma = [0]*nPrimes
        chroma[chromaticPrime]=1
        scale = temper.temperOut(vectors[1:])
        if scale.invariant() != firstMapping:
          print "discrepancy"
          print firstMapping
          scale.optimizeRMS()
          print scale.invariant()
        break
      else:
        print "chroma not found"
    except temper.TemperamentException, te:
      print te

