#!/usr/bin/python 
# originally duplicated the output of write_temper.ml
# now only does RMS because that's all the C does

import sys, math
import temper

def rms_fod(self, consonances=None):
    error = self.getRMSError(consonances)
    width = self.getComplexity(consonances)
    m, n = self.primesByMelody[0]
    return width*width*error + 1e-10*width + 1e-15*m + 1.6e-15*n

def write_lts(consonances, etCutoff=0.5,
        nETs=20, highestComplexity=4, worstError=0.3):
    ets = temper.getLimitedETs(consonances, nETs, etCutoff)
    print ' '.join(map(str, ets))

    for lt in temper.getLinearTemperaments(
            ets,
            consonances,
            rms_fod,
            len(consonances)*highestComplexity,
            worstError,
            1)[:100]:
        print lt.invariant(),
    print "\n"

oddLimits = map(temper.OddLimit, (5,7,9,11,13,15,17,19,21))

tubulongFrequencies = []
for s in range(3,9):
  tubulongFrequencies.append(
      math.sqrt( float(s*(s*s - 1))**2 / (s*s + 1))
      / math.sqrt(36.0/5))

primes = map(temper.log2, tubulongFrequencies)
equivalence = temper.log2(tubulongFrequencies[0])
equiv_primes = []
for f in tubulongFrequencies[1:]:
    equiv_primes.append(temper.log2(f)/equivalence)

if __name__=='__main__':
    print "RMS Optima\n"
    for limit in oddLimits:
      write_lts(limit)

    print "Inconsistent ETs\n"
    for limit in oddLimits:
      write_lts(limit, etCutoff=0.6)

    print "Microtemperaments\n"
    for limit in oddLimits:
      write_lts(limit, nETs=25, highestComplexity=6, worstError=2/12e2)

    for f in tubulongFrequencies:
      print "%.5f"%f,
    print ''

    print "Octave-Equivalent Tubulongs\n"
    for dimensions in range(2, len(primes)+1):
        limit = temper.PrimeDiamond(dimensions)
        limit.primes = primes[:dimensions]
        write_lts(limit, etCutoff=0.501, worstError = 0.02)
        # different et cutoff to get consistent results for exactly 0.5

    print "Tubulongs with Equivalence Interval of %.6f\n"%equivalence
    for dimensions in range(2, len(equiv_primes)+1):
        limit = temper.PrimeDiamond(dimensions)
        limit.primes = equiv_primes[:dimensions]
        write_lts(limit, worstError = 0.02)

