#!/usr/local/bin/python

import temper, string, math, time


def figureOfDemeritByMOS(self, consonances=None):
  error = self.getWorstError(consonances)
  width = self.getSmallestContainingMOS(mustBeProper=0)
  return width*width*error

def gaussianFOD(self, consonances=None):
    try:
      error = self.lastOptimum
      width = self.lastComplexity
    except AttributeError:
      error = self.lastOptimum = self.getWorstError(consonances)
      width = self.lastComplexity = self.getComplexity(consonances)
    return width**2 * math.exp((error/self.stdError*3)**2)

def badnessForKeyboardMapping(self, consonances=None):
  if self.isUnique(consonances):
    return self.getComplexity()
  else:
    return self.getComplexity()*2

limits = []
for limit in range(5,22,2):
  limits.append('limit%i'%limit)

def writeFiles(
    suffix,
    FOD=None,
    highestComplexity = 4,
    worstError=0.3,
    primes = temper.primes,
    nETs=20,
    etCutoff = 0.5,
    nResults  = 10,
    useRMS=0):

  timestamp = time.time()

  for limit in limits:
    consonances = vars(temper)[limit]
    if len(consonances[0]) > len(primes):
      break
    consonances.primes = primes[:len(consonances[0])]
    print limit,
    f = open(limit+suffix,'w')
    consist = temper.getLimitedETs(consonances,
      nETs,
      etCutoff)
    f.write(string.join(map(str, consist), " "))

    temperaments = temper.getLinearTemperaments(consist,
        figureOfDemerit = FOD,
        highestComplexity = len(consonances)*highestComplexity,
        worstError = worstError,
        useRMS=useRMS)

    for temperament in temperaments[:nResults]:
      f.write("\n\n%s\n\n%s\n\n" % (
          temperament, temperament.formatEquivalences()
      ))
      consistentETs = []
      period = temperament.mapping[0][0]
      vectors = temperament.getUnisonVectors()
      for et in consist:
        if et.basis[0]%period==0:
          for vector in vectors:
            if temper.dotprod(vector, et.basis):
              break
          else:
            consistentETs.append(et.basis[0])
      f.write("consistent with: "+string.join(map(str, consistentETs),  ", "))
    f.close()
  print
  print suffix, time.time()-timestamp

writeFiles('.txt', useRMS=1, nETs=20)
writeFiles('.minimax', useRMS=0, nETs=20)
writeFiles('.inconsistent', etCutoff=0.6)
writeFiles('.gauss',gaussianFOD, nETs=25, highestComplexity=6, nResults=30, worstError=None)
writeFiles('.key', badnessForKeyboardMapping)
writeFiles('.micro', worstError = 2.0/1200, nETs=25,highestComplexity=6)

tubulongFrequencies = []
for s in range(3,9):
  tubulongFrequencies.append(
      math.sqrt( float(s*(s*s - 1))**2 / (s*s + 1))
      / math.sqrt(36.0/5))

for f in tubulongFrequencies:
  print "%.5f"%f,
print

writeFiles('.tubulong',
  primes = map(temper.log2, tubulongFrequencies),
      worstError = 0.02)

equivalence = temper.log2(tubulongFrequencies[0])
print "new equivalence interval %.6f"%equivalence
equivalentPrimes = []
for f in tubulongFrequencies[1:]:
  equivalentPrimes.append(temper.log2(f)/equivalence)
writeFiles('.tubulong.nonoctave',
    primes = equivalentPrimes,
    worstError = 0.02)



